import { ConcreteTypeOf, FieldArgs, FieldDefinition, GenericSchema, InterfaceType, ObjectType, OperationRootTypeOf, OperationsOf, OperationTypes, UnionType } from './schema';
import { IsTrueOrHasOnlyOptionals, PickFirstTupleItemThatExtends, RequireAtLeastOne, RequiredWhenChildrenAreRequired, SetRequired, StripImpossibleProperties, ToUnion, UnwrapArray, UnwrapNullableArray, WrapArray } from './type-helpers';
declare type ParametersOf<Schema extends GenericSchema, OperationType extends OperationTypes, Element extends Record<string, any>, Definition, FieldName extends string | undefined, FieldTypeRef extends FieldDefinition = Definition extends {
    fields: readonly any[];
} ? PickFirstTupleItemThatExtends<Definition['fields'], {
    name: FieldName;
}> : Definition extends FieldDefinition ? Definition : never, FieldType extends ObjectType | InterfaceType | UnionType = ConcreteTypeOf<Schema, FieldTypeRef['type']>, HasArgs = FieldTypeRef extends {
    args: readonly any[];
} ? FieldTypeRef['args']['length'] extends 0 ? false : true : false, Args = HasArgs extends true ? unknown extends FieldArgs<Schema, OperationType, FieldTypeRef['name']> ? FieldArgs<Schema, OperationType, FieldType['name']> : FieldArgs<Schema, OperationType, FieldTypeRef['name']> : never, Fields = {
    [key in keyof Element]?: UnwrapNullableArray<Element[key]> extends object ? ParametersOf<Schema, OperationType, UnwrapNullableArray<Element[key]>, FieldType, string & key> | true : true;
}, Select = {
    select?: Fields;
}, Variables = RequiredWhenChildrenAreRequired<'variables', Args>, OnFields = FieldType extends SetRequired<UnionType | InterfaceType, 'possibleTypes'> ? {
    [key in FieldType['possibleTypes'][number] as key['name']]?: ParametersOf<Schema, OperationType, Schema['types'][key['name']], {
        name: key['name'];
        type: ConcreteTypeOf<Schema, key>;
    }, undefined> | true;
} : never, On = FieldType extends SetRequired<UnionType, 'possibleTypes'> ? {
    on: RequireAtLeastOne<OnFields>;
} : FieldType extends SetRequired<InterfaceType, 'possibleTypes'> ? {
    on?: OnFields;
} : {}> = Select & Variables & On;
declare type QueryFields<Params extends {
    select?: any;
}, Element, UnwrappedParams extends {
    select?: any;
} = UnwrapArray<Params>> = UnwrappedParams extends undefined ? Element : WrapArray<NonNullable<Element>, IsTrueOrHasOnlyOptionals<UnwrappedParams['select']> extends true ? StripImpossibleProperties<{
    [k in keyof NonNullable<Element>]: k extends keyof UnwrapArray<Element> ? UnwrapArray<NonNullable<Element>>[k] extends object ? never : UnwrapArray<Element>[k] : never;
}> : StripImpossibleProperties<{
    [k in keyof UnwrappedParams['select']]: k extends keyof UnwrapArray<Element> ? UnwrapArray<NonNullable<Element>>[k] extends object ? QueryFields<UnwrappedParams['select'][k], UnwrapArray<Element>[k]> : UnwrapArray<Element>[k] : never;
}>>;
declare type UnionFields<Schema extends GenericSchema, Params extends {
    on: any[];
}, Fragments = NonNullable<NonNullable<Params>['on']>> = ToUnion<{
    [fragmentName in keyof Fragments]: {
        __typename: NonNullable<Schema['types'][string & fragmentName]['__typename']>;
    } & QueryFields<NonNullable<Fragments[fragmentName]>, Schema['types'][string & fragmentName]>;
}>;
declare type Exactly<T, U> = T & Record<Exclude<keyof U, keyof T>, never>;
export declare type OperationFactory<Schema extends GenericSchema | undefined, OperationType extends OperationTypes, Operations = Schema extends GenericSchema ? OperationsOf<Schema, OperationType> : {}> = Schema extends GenericSchema ? Required<{
    [name in keyof Operations]: <Operation extends Operations[name], Element extends UnwrapArray<Operation>, Params extends ParametersOf<Schema, OperationType, NonNullable<Element>, OperationRootTypeOf<Schema, OperationType>, string & name>, ExactParams extends Exactly<Params, ExactParams>, Result extends WrapArray<Operation, ExactParams extends {
        on: any;
    } ? (UnionFields<Schema, ExactParams> & QueryFields<ExactParams, Element>) | ({
        __typename: Element extends {
            __typename: any;
        } ? Element['__typename'] : null;
    } & QueryFields<ExactParams, Element>) : QueryFields<ExactParams, Element>>>(...parameters: ExactParams extends {
        variables: any;
    } | {
        on: any;
    } ? [ExactParams] : [ExactParams?]) => Promise<Result>;
}> : {};
export {};
//# sourceMappingURL=types.d.ts.map